require "defines"
require "landing"
require "robotypes"
require "range_visualisation"

local ex2item=robotypes.ex2item

range_visualisation.register_self()

script.on_init(
    function()
        landing.init(s)
    end)
script.on_event(defines.events.on_trigger_created_entity,
    function(e) 
        if ex2item[e.entity.name] then 
            landing.commence(landing.find_pad(e.entity),e.entity)
        end
    end)
script.on_event({defines.events.on_built_entity,defines.events.on_robot_built_entity},
    function(e)
        if e.created_entity.name=="drone-landing-pad" then
            landing.add_pad(e.created_entity)
        end
    end)
script.on_event({defines.events.on_entity_died,defines.events.on_robot_pre_mined_item,defines.events.on_preplayer_mined_item,},
    function(e)
        if e.entity.name=="drone-landing-pad" then
            landing.rem_pad(e.entity)
            landing.check_pads()--check for somehow lost entities
        end
    end)
script.on_configuration_changed(
    function(d)
        if d.mod_changes and d.mod_changes.DroneHome and not d.mod_changes.DroneHome.old_version then
            game.reset_recipes()
            game.reset_technology()
        end
    end)
