require "util"
require "robotypes"

--Drone stuff here. Generated programmatically
local types=robotypes.robots

local icons=robotypes.icons--icons for known types of broken robots
local re_icons=robotypes.re_icons
local ingredients=robotypes.ingredients--ingredients to recharge drones
local function gen_exp(name)--make drone death trackable, currently there's no way to determine deathcause
  return {
    type = "explosion", name = "ex-"..name, flags = {"not-on-map"},
    animations =
    {{  filename = "__core__/graphics/empty.png",
        priority = "extra-high",
        width = 1,height = 1,frame_count = 1,animation_speed = 1
      }},
  }
end
local function gen_proj(name)--this projectile will be used to signify loading process
    local res = data.raw.projectile[name..'-capsule'] and table.deepcopy(data.raw.projectile[name..'-capsule']) or table.deepcopy(data.raw.projectile['defender-capsule'])
    res.name="ded-"..name
    res.action=nil
    return res
end
local function gen_used_drone(name)--this item is drone to be repaired
    local res ={
    type = "item",
    name = 'ded-'..name,
    icon = icons[name],
    flags = {"goes-to-main-inventory"},
    subgroup = "capsule",
    order = "g[expired-capsule]",
    stack_size = 80}
    return res
end
local function gen_recipe(name)--this is recipe make drone functional again
    local res={type = "recipe",
    name = "recharge-"..name,
    icon = re_icons[name],
    enabled = false,
    energy_required = 6,
    ingredients =ingredients[name],
    result = name.."-capsule",
    }
    for _,k in pairs(res.ingredients) do
        --print(serpent.block(
        for n,i in pairs(k) do
            if i=="self" then k[n]="ded-"..name end
        end
    end
  return res
end
local new_ents={}--entities to be added to a game
for _,n in pairs(robotypes.robots) do
    v=data.raw["combat-robot"][n]
    if v then
        v.destroy_action.action_delivery.source_effects.trigger_created_entity=true
        v.destroy_action.action_delivery.source_effects.entity_name="ex-"..v.name
        table.insert(new_ents,gen_exp(v.name))
        table.insert(new_ents,gen_proj(v.name))
        table.insert(new_ents,gen_used_drone(v.name))
        table.insert(new_ents,gen_recipe(v.name))
    end
end
for _,t in pairs(data.raw.technology) do--put recharge recipes to same tech as the robot itself
    if t.effects then
        for _,e in pairs(t.effects) do if e.type=="unlock-recipe" then
            for _,r in pairs(types) do if e.recipe==r..'-capsule' then
                table.insert(t.effects,{type="unlock-recipe", recipe="recharge-"..r})
            end end
        end end
    end
end
--make landing pad
local pad=table.deepcopy(data.raw['smart-container']['smart-chest'])
pad.name="drone-landing-pad"
pad.inventory_size=3
pad.fast_replaceable_group=nil
pad.minable = {hardness = 0.2, mining_time = 1, result = "drone-landing-pad"}
pad.icon="__DroneHome__/landing-pad-icon.png"
pad.picture={
      filename = "__DroneHome__/landing-pad.png",
      priority = "extra-high",
      width = 106,
      height = 84,
      scale=32/60,
      shift = {0.2, -0.2}
    }
local pad_item=table.deepcopy(data.raw.item['iron-chest'])
pad_item.name="drone-landing-pad"
pad_item.place_result = "drone-landing-pad"
pad_item.stack_size = 10
pad_item.subgroup = "capsule"
pad_item.order = "g[landing-pad]"
pad_item.icon = "__DroneHome__/landing-pad-icon.png"
local pad_recipe={
    type = "recipe",enabled = false,
    name = "drone-landing-pad",
    ingredients ={
      {"steel-chest",1},{"plastic-bar", 5},{"iron-gear-wheel", 5},
      {"basic-inserter", 1}},
    result = "drone-landing-pad"
  }
local pad_tech={type = "technology",
    name = "drone-landing",
    icon = "__DroneHome__/landing-pad-tech.png",
    icon_size = 128,
    effects ={
        {type = "unlock-recipe",recipe = "drone-landing-pad"}
    },
    prerequisites = {"combat-robotics"},
    unit ={count = 150,ingredients = {{"science-pack-1", 1,},{"science-pack-2", 1}},time = 30},
    order ="e-p-a-b"
  }
table.insert(new_ents,pad)
table.insert(new_ents,pad_item)
table.insert(new_ents,pad_recipe)
table.insert(new_ents,pad_tech)

--create landing visualisation entity
local range_marker=
    {
        type = "decorative",
        name = "drone-landing-range-marker",
        flags = { "not-on-map"},
        collision_mask = {},
        subgroup = "grass",
        order = "b[decorative]-b[drone-landing-range-marker]",
        collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
        selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
        selectable_in_game = false,
        render_layer = "radius-visualization",
        pictures = {
            {
                filename = "__core__/graphics/diode-green.png",
                width = 20,
                height = 20
            }
        }
    }
    table.insert(new_ents,range_marker)
data:extend(new_ents)
