require "robotypes"
--global parameters of mod
local l_r=robotypes.landing_range--landing_radius
local ex2proj=robotypes.ex2proj
local ex2item=robotypes.ex2item
local abs=function(x) return x>0 and x or -x end

--drone pickup
landing={
    --a set of functions that handle landing of bots
    --global.pads is a queue of entities where bots can land
    --I've chosen it to be so in hopes of get implicit quasi-caching by elements shuffling
    init=function()
            global.pads=global.pads or {}
            for _,s in pairs(game.surfaces) do
                global.pads[s.name]=global.pads[s.name] or {l=0,r=-1}
            end
        end,
    add_pad=function(entity)
            if not global.pads[entity.surface.name] then landing.init() end
            local p=global.pads[entity.surface.name]
            p.r=p.r+1
            p[p.r]=entity
        end,
    rem_pad=function(entity)
            local p=global.pads[entity.surface.name]
            for i=p.l,p.r,1 do
                if p[i]==entity then p[i]=p[p.l]; p.l=p.l+1; break end;
            end
        end,
    find_pad=function(entity)--search pad within range and where robot can land
            local p=global.pads[entity.surface.name]
            if not p then return end
            local pos=entity.position
            local name=ex2item[entity.name]
            
            local pap=p[p.l].position
            if abs(pap.x-pos.x)<l_r and abs(pap.y-pos.y)<l_r and p[i].can_insert(name) then
                return p[p.l]
            else 
                for i=p.l+1,p.r,1 do
                    pap=p[i].position
                    if abs(pap.x-pos.x)<l_r and abs(pap.y-pos.y)<l_r and p[i].can_insert(name) then
                        p[p.l-1]=p[i]; p[i]=p[p.r]; p[p.r]=nil; p.l=p.l-1; p.r=p.r-1;
                        return p[p.l]
                    end 
                end
            end
        end,
    commence=function(pad,ent)--send a robot flying from pos to pad and put item in pad
            if pad then
                pad.surface.create_entity{name=ex2proj[ent.name],position=ent.position,target=pad,speed=0.5}
                pad.insert{name=ex2item[ent.name]}
            else
                ent.surface.create_entity{name="explosion",position=ent.position}
            end
        end,
    check_pads=function()
            for _,s in pairs(game.surfaces) do
                local p=global.pads[s.name]
                for i=p.l,p.r,1 do
                    if not p[i].valid then p[i]=p[p.l]; p.l=p.l+1; end;
                end
            end
        end,
}
