require "robotypes"

local l_r=robotypes.landing_range
local circ={}
for x=0,l_r,1 do
    local y=math.floor(math.sqrt(l_r*l_r-x*x))
    table.insert(circ,{x=x,y=y})
    table.insert(circ,{x=x,y=-y})
    table.insert(circ,{x=-x,y=y})
    table.insert(circ,{x=-x,y=-y})
end

range_visualisation={
    register_self=function()
        if remote.interfaces.WrenchFu then 
            remote.call("WrenchFu","register","drone-landing-pad","Landing-Wrench","show_range","hide_range",6)
            remote.add_interface("Landing-Wrench",{
                show_range=function(player_index, entity_name, position)
                    range_visualisation.commence(player_index,position)
                end,
                hide_range=function(player_index, entity_name, position)
                    range_visualisation.decommence(player_index)
                end,
                }
            )
        end
    end,
    
    commence=function(pind, pos)
        global.range=global.range or {}
        global.range[pind]=global.range[pind] or {}
        local s=game.players[pind].surface
        for _,d in pairs(circ) do
            table.insert(global.range[pind],
                s.create_entity{name="drone-landing-range-marker",position={x=pos.x+d.x,y=pos.y+d.y}}
                )
        end
    end,
    decommence=function(pind)
        for _,e in pairs(global.range[pind]) do
            e.destroy()
        end
        global.range[pind]=nil
    end
}
